
package ru.pp.rux.fallingball.canvas;

import java.io.IOException;
import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

import ru.pp.rux.fallingball.SmallMidlet;

/**
 *
 * @author ruX[Ruslan Zaharov]
 * 2010 (c) http://ruX.pp.ru
 */
public class WelcomeCanvas extends Canvas {

    private Image welcomeImage = null;

    public WelcomeCanvas() {
        super();
        setFullScreenMode(true);
        repaint();
    }

    public Image getWelcomeImage() {
        if (welcomeImage == null) {
            try {
                welcomeImage = Image.createImage("/resource/falling-ball.jpg");
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
        return welcomeImage;
    }

    protected void paint(Graphics g) {
        g.setColor(0xff, 0xff, 0xff);
        g.fillRect(0, 0, getWidth(), getHeight());

        g.drawImage(getWelcomeImage(), getWidth()/2 - getWelcomeImage().getWidth()/2,
                (getHeight()/2 - 20) - getWelcomeImage().getHeight()/2, 0);

        g.setColor(0, 0, 0xff);

        g.drawString("Hit any key to continue", 5,
                getHeight() - g.getFont().getHeight() - 3, 0);
    }

    /**
     * Go to next scene
     */
    protected void goNextScreen() {
        SmallMidlet.getDisplay().setCurrent(new FallingBall());
    }

    /**
     * Tap on screen? So go next
     */
    protected void pointerPressed(int x, int y) {
        goNextScreen();
    }

    /**
     * Keyboard touched? Go next
     */
    protected void keyPressed(int code) {
        goNextScreen();
    }


}
