
package ru.pp.rux.fallingball.util;

/**
 * pow and log math functions
 * used code form http://discussion.forum.nokia.com/forum/showthread.php?t=60817
 *
 * @author ruX[Ruslan Zaharov]
 * 2010 (c) http://ruX.pp.ru
 */
public class SomeMath {

    public static double pow(double base, int exp) {
        if (exp == 0) return 1;
        double res = base;
        for (; exp > 1; --exp)  res *= base;
        return res;
    }

    public static double log(double x) {
        long l = Double.doubleToLongBits(x);
        long exp = ((0x7ff0000000000000L & l) >> 52) - 1023;
        double man = (0x000fffffffffffffL & l) / (double) 0x10000000000000L + 1.0;
        double lnm = 0.0;
        double a = (man - 1) / (man + 1);
        for (int n = 1; n < 7; n += 2) lnm += pow(a, n) / n;
        return 2 * lnm + exp * 0.69314718055994530941723212145818;
    }

    /**
     * this one copy & pasted from
     * http://www.gamedev.net/community/forums/topic.asp?topic_id=441464
     */
    public static double aTan2(double y, double x) {
        double coeff_1 = Math.PI / 4d;
        double coeff_2 = 3d * coeff_1;
        double abs_y = Math.abs(y);
        double angle;
        if (x >= 0d) {
            double r = (x - abs_y) / (x + abs_y);
            angle = coeff_1 - coeff_1 * r;
        } else {
            double r = (x + abs_y) / (abs_y - x);
            angle = coeff_2 - coeff_1 * r;
        }
        return y < 0d ? -angle : angle;
    }

}
